﻿using SofrwareInstallationContracts.BindingModels;
using SofrwareInstallationContracts.ViewModels;
using SoftwareInstallationDataModels.Models;

namespace SoftwareInstallationListImplement.Models
{
    public class Package : IPackageModel
    {
        public string PackageName { get; private set; } = string.Empty;

        public double Price { get; private set; }

        public Dictionary<int, (IComponentModel, int)> PackageComponents { get; private set; } = new Dictionary<int, (IComponentModel, int)>();

        public int Id { get; private set; }

        public static Package? Create(PackageBindingModel? model)
        {
            if (model == null)
            {
                return null;
            }
            return new Package()
            {
                Id = model.Id,
                PackageName = model.PackageName,
                Price = model.Price,
                PackageComponents = model.PackageComponents
            };
        }

        public void Update(PackageBindingModel? model)
        {
            if (model == null)
            {
                return;
            }
            PackageName = model.PackageName;
            Price = model.Price;
            PackageComponents = model.PackageComponents;
        }

        public PackageViewModel GetViewModel => new()
        {
            Id = Id,
            PackageName = PackageName,
            Price = Price,
            PackageComponents = PackageComponents
        };
    }
}
